> ## Documentation Index
> Fetch the complete documentation index at: https://docs.immutable.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List ERC20 tokens

> List ERC20 tokens



## OpenAPI

````yaml https://imx-openapiv3-mr-sandbox.s3.us-east-2.amazonaws.com/openapi.json get /v1/chains/{chain_name}/tokens
openapi: 3.0.3
info:
  title: Immutable zkEVM API
  version: 1.0.0
  description: Immutable Multi Rollup API
  contact:
    name: Immutable API Support
    email: support@immutable.com
    url: https://support.immutable.com
servers:
  - url: https://api.sandbox.immutable.com
security: []
tags:
  - name: activities
    description: Activities Endpoints
    x-displayName: activities
  - name: chains
    description: Chains Endpoints
    x-displayName: chains
  - name: collections
    description: Collections Endpoints
    x-displayName: collections
  - name: nfts
    description: NFTs Endpoints
    x-displayName: nfts
  - name: nft owners
    description: NFT Owner Endpoints
    x-displayName: nft owners
  - name: metadata
    description: NFT Metadata Endpoints
    x-displayName: metadata
  - name: tokens
    description: ERC20 Token Endpoints
    x-displayName: tokens
  - name: demopage
    description: Temporary HTML endpoint for demo purposes
    x-displayName: demopage
  - name: verification
    x-displayName: verification
  - name: operatorallowlist
    x-displayName: operatorallowlist
  - name: crafting
    x-displayName: crafting
  - name: listings
    description: Listings Endpoints
    x-displayName: listings
  - name: orders
    x-displayName: orders
  - name: passport
    description: Passport operations
    x-displayName: passport
  - name: gamefi
    description: team gamefi
    x-displayName: gamefi
  - name: health
    x-displayName: health
  - name: passport profile
    description: Passport Profile endpoints
    x-displayName: passport profile
  - name: feed-items
    x-displayName: feed-items
  - name: assets
    x-displayName: assets
  - name: guardian
    description: Guardian endpoints
    x-displayName: guardian
  - name: pricing
    description: Pricing Endpoints
    x-displayName: pricing
  - name: metadata-search
    x-displayName: metadata-search
paths:
  /v1/chains/{chain_name}/tokens:
    get:
      tags:
        - tokens
      summary: List ERC20 tokens
      description: List ERC20 tokens
      operationId: ListERC20Tokens
      parameters:
        - name: chain_name
          description: The name of chain
          in: path
          required: true
          schema:
            $ref: '#/components/schemas/ChainName'
        - name: from_updated_at
          in: query
          description: Datetime to use as the oldest updated timestamp
          required: false
          schema:
            type: string
            example: '2022-08-16T17:43:26.991388Z'
            format: date-time
        - name: verification_status
          in: query
          required: false
          description: List of verification status to filter by
          schema:
            type: array
            items:
              $ref: '#/components/schemas/AssetVerificationStatus'
        - name: is_canonical
          in: query
          required: false
          description: >-
            [Experimental - Canonical token data may be updated] Filter by
            canonical or non-canonical tokens.
          schema:
            type: boolean
        - name: page_cursor
          in: query
          description: >-
            Encoded page cursor to retrieve previous or next page. Use the value
            returned in the response.
          required: false
          schema:
            $ref: '#/components/schemas/PageCursor'
        - name: page_size
          description: Maximum number of items to return
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/PageSize'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListTokensResult'
        '400':
          $ref: '#/components/responses/BadRequest'
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/InternalServerError'
components:
  schemas:
    ChainName:
      type: string
      description: The name of chain
      example: imtbl-zkevm-testnet
    AssetVerificationStatus:
      description: The verification status for a given contract
      type: string
      enum:
        - verified
        - unverified
        - spam
        - inactive
    PageCursor:
      type: string
      description: >-
        Encoded page cursor to retrieve previous or next page. Use the value
        returned in the response.
      example: >-
        ewogICJ0eXBlIjogInByZXYiLAogICJpdGVtIjogewogICAgImlkIjogNjI3NTEzMCwKICAgICJjcmVhdGVkX2F0IjogIjIwMjItMDktMTNUMTc6MDQ6MTIuMDI0MTI2WiIKICB9Cn0=
    PageSize:
      type: integer
      format: int32
      description: Maximum number of items to return
      minimum: 1
      default: 100
      maximum: 200
      example: 10
    ListTokensResult:
      type: object
      properties:
        result:
          type: array
          description: List of tokens
          items:
            $ref: '#/components/schemas/Token'
        page:
          $ref: '#/components/schemas/Page'
      required:
        - result
        - page
    Token:
      type: object
      properties:
        chain:
          $ref: '#/components/schemas/Chain'
        contract_address:
          type: string
          description: The address of token contract
          example: '0xc344c05eef8876e517072f879dae8905aa2b956b'
        root_contract_address:
          type: string
          description: The address of root token contract
          example: '0x43e60b30d5bec48c0f5890e3d1e9f1b1296bb4aa'
          nullable: true
        root_chain_id:
          type: string
          description: The id of the root chain for a bridged token
          example: eip155:1
          nullable: true
        bridge_used:
          type: string
          description: The name of the bridge, for bridged tokens only
          example: axelar
          nullable: true
        symbol:
          type: string
          description: The symbol of token
          example: AAA
          nullable: true
        decimals:
          type: integer
          description: The decimals of token
          example: 18
          nullable: true
        image_url:
          type: string
          description: The image url of token
          example: https://some-url
          nullable: true
        name:
          type: string
          description: The name of token
          example: Token A
          nullable: true
        verification_status:
          $ref: '#/components/schemas/AssetVerificationStatus'
        updated_at:
          type: string
          format: date-time
          example: '2022-08-16T17:43:26.991388Z'
          description: When the collection was last updated
        is_canonical:
          type: boolean
          example: true
          description: Indicates whether the token is canonical or not
      required:
        - chain
        - contract_address
        - root_contract_address
        - symbol
        - decimals
        - image_url
        - name
        - updated_at
        - verification_status
        - is_canonical
    Page:
      type: object
      description: Pagination properties
      properties:
        previous_cursor:
          type: string
          nullable: true
          description: First item as an encoded string
          example: >-
            ewogICJ0eXBlIjogInByZXYiLAogICJpdGVtIjogewogICAgImlkIjogNjI3NTEzMCwKICAgICJjcmVhdGVkX2F0IjogIjIwMjItMDktMTNUMTc6MDQ6MTIuMDI0MTI2WiIKICB9Cn0=
        next_cursor:
          type: string
          nullable: true
          description: Last item as an encoded string
          example: >-
            ewogICJ0eXBlIjogInByZXYiLAogICJpdGVtIjogewogICAgImlkIjogNjI3NTEzMCwKICAgICJjcmVhdGVkX2F0IjogIjIwMjItMDktMTNUMTc6MDQ6MTIuMDI0MTI2WiIKICB9Cn0=
      required:
        - previous_cursor
        - next_cursor
    APIError400:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - VALIDATION_ERROR
              example: VALIDATION_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError404:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - RESOURCE_NOT_FOUND
              example: RESOURCE_NOT_FOUND
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError500:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - INTERNAL_SERVER_ERROR
              example: INTERNAL_SERVER_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    Chain:
      type: object
      description: The chain details
      properties:
        id:
          type: string
          description: The id of chain
          example: eip155:13372
        name:
          type: string
          description: The name of chain
          example: imtbl-zkevm-testnet
      required:
        - id
        - name
    BasicAPIError:
      type: object
      properties:
        message:
          type: string
          description: Error Message
          example: all fields must be provided
        link:
          type: string
          description: Link to IMX documentation that can help resolve this error
          example: https://docs.x.immutable.com/reference/#/
        trace_id:
          type: string
          description: Trace ID of the initial request
          example: e47634b79a5cd6894ddc9639ec4aad26
      required:
        - message
        - link
        - trace_id
  responses:
    BadRequest:
      description: Bad Request (400)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError400'
    NotFound:
      description: The specified resource was not found (404)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError404'
    InternalServerError:
      description: Internal Server Error (500)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError500'

````